#[allow(dead_code)]
fn find_peaks_and_valleys(values: &[isize]) -> Vec<usize> {
    values
        .windows(3) // Take three consecutives elements at once
        .enumerate() // Get the index of the first one
        .map(|(idx, arr)| (idx, [arr[0], arr[1], arr[2]])) // Map the elements as a fixed size array
        .filter(|(_, [a, b, c])| (b > a && b > c) || (b < a && b < c)) // Keep if the middle element is peak or valley
        .map(|(idx, _)| idx + 1) // Map to index of the middle element
        .collect() // Profit!
}

fn main() {}

#[cfg(test)]
mod tests {
    use super::*;

    #[test]
    pub fn test() {
        assert_eq!(
            find_peaks_and_valleys(&[1, 2, 1, 3, 4, 5, 4, 3, 2, 1, 2, 3]),
            vec![1, 2, 5, 9]
        );
    }

    #[test]
    pub fn test_flat() {
        assert_eq!(find_peaks_and_valleys(&[1, 1, 1, 1]), vec![]);
    }

    #[test]
    pub fn test_up_and_down() {
        assert_eq!(
            find_peaks_and_valleys(&[1, 0, 1, 0, 1, 0]),
            vec![1, 2, 3, 4]
        );
    }

    #[test]
    pub fn test_negative() {
        assert_eq!(
            find_peaks_and_valleys(&[-5, -10, -7, -15, -12]),
            vec![1, 2, 3]
        );
    }
}
